# Vaxe

## Links
- [Docs](https://vaxe.ml/) *(Soon)*
- [Discord](https://discord.gg/yYJbYbHXp4)

## Install
```sh
npm i vaxe
```

## Using
```js
const vaxe = require("vaxe")
```

## Help
Run in shell:
```sh
vaxe help
```
## Input
```js
let value = vaxe.input()
```
*Option:* Value
## Print
```js
vaxe.print("Vaxe");
vaxe.printIn("Vaxe");
```
## Random
```js
vaxe.random(["a", "b", "c"]);
vaxe.random(5) // 0-5
```
## Generate
```js
vaxe.generate("str", loop); // a-Z
vaxe.generate("strUp", loop); // A-Z
vaxe.generate("strLow", loop); // a-z
vaxe.generate("num", loop); // 0-9
```
### loop
The number of characters that came out of the generator (set to 9 by default)
# Route
```js
const route = vaxe.route()
```
## Setup
```js
route.setup(data, port [option])
```
# Data
Data can be a json list or a filename. The package will extract the data itself.
```js
{
  "/example": {
    "type": "content",
    "value": "hello world!"
  }
}
```
- Type - The type of sending can be **content** which is plain text or **file** and then the software will send a file.
- Value - Can be a plain text value if the selected type is **content** or a file name if the selected type is **file**.
- Link - Transfers to the link found in value.

Status - You can add a status to the page.
```json
{
  "/": {
    "status": "200"
  }
}
```
Console - Sends a value to the console on login.
```json
{
  "/": {
    "console": "hello world!"
  }
}
```
# Port [option]
You can choose the port where the program will run but it is not mandatory and you can run a port in any way you choose.
# Extra
- You can add a value called "404" which will be executed if no other value is suitable.
- **cmd** - Adds translation to command values.
```json
{
  "/": {
    "cmd": true,
    "console": "run path: $path \n user joined, IP: $ip"
  }
}
```
$ip = IP
$path = PATH
## Port
```js
route.port(port)
```
Port definition for the software
## Static
```js
route.static("DIR")
```